      PROGRAM MAIN
C
C
      CALL MATLAB(0)
      STOP
      END
      SUBROUTINE FILES(LUNIT,NAME,IOSTAT)
      INTEGER LUNIT,NAME(64),IOSTAT
C
C     SYSTEM DEPENDENT ROUTINE TO ALLOCATE FILES
C     LUNIT = LOGICAL UNIT NUMBER
C           = 1,  SAVE
C           = 2,  LOAD
C           = 7,  PRINT
C           = 8,  DIARY
C           > 10, EXEC
C           < 0,  CLOSE -LUNIT
C           = -5, SPECIAL CASE, END OF FILE DETECTED ON TERMINAL
C     NAME = FILE NAME, 1 CHARACTER PER WORD
C     NONZERO IOSTAT RETURNED FOR ERROR CONDITION
C
C     (UNLESS CHANGED IN SUBROUTINE MATLAB, UNITS 5, 6 AND 9 ARE
C      USED FOR TERMINAL INPUT, TERMINAL OUTPUT AND THE HELP FILE.
C      THE HELP FILE IS OPENED BY SUBROUTINE HELPER.)
C
      CHARACTER*64 NAM
C
      IF (LUNIT .LT. 0) GO TO 30
C
C     FORTRAN 77 INTERNAL FILE CONVERSION FROM 64A1 TO CHARACTER*64
C
      DO 1000 I=1,64
        NAM(I:I)=CHAR(NAME(I))
 1000 CONTINUE
C
C     UNFORMATTED I/O FOR SAVE AND LOAD
C     FORMATTED I/O FOR EXEC, DIARY AND PRINT
C
      IOSTAT = 0
      IF (LUNIT .EQ. 1)  OPEN(UNIT=LUNIT,FILE=NAM,FORM='UNFORMATTED',
     >                   STATUS='NEW',ERR=20,IOSTAT=IOSTAT)
      IF (LUNIT .EQ. 2)  OPEN(UNIT=LUNIT,FILE=NAM,FORM='UNFORMATTED',
     >                   STATUS='OLD',ERR=20,IOSTAT=IOSTAT)
      IF (LUNIT .EQ. 7)  OPEN(UNIT=LUNIT,FILE=NAM,
     >                   STATUS='NEW',ERR=20,IOSTAT=IOSTAT)
      IF (LUNIT .EQ. 8)  OPEN(UNIT=LUNIT,FILE=NAM,
     >                   STATUS='NEW',ERR=20,IOSTAT=IOSTAT)
      IF (LUNIT .GT. 10) OPEN(UNIT=LUNIT,FILE=NAM,
     >                   STATUS='OLD',ERR=20,IOSTAT=IOSTAT)
      IF (IOSTAT .NE. 0) GO TO 20
C
C     REWIND ALL EXCEPT DIARY
C
      IF (LUNIT .NE. 8) REWIND LUNIT
      RETURN
C
C     ERROR ON OPEN
C
   20 IF (IOSTAT .EQ. 0) IOSTAT = -1
      RETURN
C
C     CLOSE FILES
C
   30 IF (LUNIT .EQ. -5) GO TO 50
      CLOSE(UNIT=-LUNIT)
      RETURN
C
C     UNIX SPECIAL CASE -- EOF FROM TERMINAL IMPLIES STOP
C
   50 WRITE(6,51)
   51 FORMAT(/'EOF ON TERMINAL INPUT')
      STOP
      END
      SUBROUTINE SAVLOD(LUNIT,ID,M,N,IMG,JOB,XREAL,XIMAG)
      INTEGER LUNIT,ID(4),M,N,IMG,JOB
      DOUBLE PRECISION XREAL(1),XIMAG(1)
C
C     IMPLEMENT SAVE AND LOAD
C     LUNIT = LOGICAL UNIT NUMBER
C     ID = NAME, FORMAT 4A1
C     M, N = DIMENSIONS
C     IMG = NONZERO IF XIMAG IS NONZERO
C     JOB = 0     FOR SAVE
C         = SPACE AVAILABLE FOR LOAD
C     XREAL, XIMAG = REAL AND OPTIONAL IMAGINARY PARTS
C
C     THIS VERSION USES UNFORMATTED READ AND WRITE
C
      IF (JOB .GT. 0) GO TO 20
C
C     SAVE
   10 WRITE(LUNIT) ID,M,N,IMG
      DO 15 J = 1, N
         K = (J-1)*M+1
         L = J*M
         WRITE(LUNIT) (XREAL(I),I=K,L) 
         IF (IMG .NE. 0) WRITE(LUNIT) (XIMAG(I),I=K,L)
   15 CONTINUE
      RETURN
C
C     LOAD
   20 READ(LUNIT,END=30) ID,M,N,IMG
      IF (M*N .GT. JOB) GO TO 30
      DO 25 J = 1, N
         K = (J-1)*M+1
         L = J*M
         READ(LUNIT,END=30) (XREAL(I),I=K,L)
         IF (IMG .NE. 0) READ(LUNIT,END=30) (XIMAG(I),I=K,L)
   25 CONTINUE
      RETURN
C
C     END OF FILE
   30 M = 0
      N = 0
      RETURN
      END
      SUBROUTINE FORMZ(LUNIT,X,Y)
      DOUBLE PRECISION X,Y
C
C     SYSTEM DEPENDENT ROUTINE TO PRINT WITH Z FORMAT
C
C     IF (Y .NE. 0.0D0) WRITE(LUNIT,10) X,Y
C     IF (Y .EQ. 0.0D0) WRITE(LUNIT,10) X
C  10 FORMAT(2Z18)
C
      DOUBLE PRECISION XX
      INTEGER IX(2),NOHI,SIG,P(16)
      CHARACTER*1 D(16),S(16)
      EQUIVALENCE (XX,IX)
      DATA D/'0','1','2','3','4','5','6','7',
     >       '8','9','A','B','C','D','E','F'/
      DATA P/4,3,2,1,8,7,6,5,12,11,10,9,16,15,14,13/
      DATA NOHI/$7FFFFFFF/
      XX = X
      K = 1
      DO 20 I = 1, 2
         M = IX(I)
         IF (M .LT. 0) THEN
            SIG = 1
            M = IAND(M,NOHI)
         ELSE
            SIG = 0
         ENDIF
         DO 20 J = 1, 8
            L = MOD(M,16)+1
            M = M/16
            IF (J.EQ.8 .AND. SIG.EQ.1) L = L+8
            S(P(K)) = D(L)
            K = K+1
   20 CONTINUE
      WRITE(LUNIT,100) S
  100 FORMAT (6X,16A1)
      RETURN
      END
      DOUBLE PRECISION FUNCTION FLOP(X)
      DOUBLE PRECISION X
C     SYSTEM DEPENDENT FUNCTION
C     COUNT AND POSSIBLY CHOP EACH FLOATING POINT OPERATION
C     FLP(1) IS FLOP COUNTER
C     FLP(2) IS NUMBER OF PLACES TO BE CHOPPED
C
      INTEGER SYM,SYN(4),BUF(256),CHAR,FLP(2),FIN,FUN,LHS,RHS,RAN(2)
      COMMON /COM/ SYM,SYN,BUF,CHAR,FLP,FIN,FUN,LHS,RHS,RAN
C
      DOUBLE PRECISION MASK(14),XX,MM
      INTEGER MAS(2,14)
      INTEGER XEXP,IBMASK(3)
      INTEGER LX(2),LM(2)
      EQUIVALENCE (LX(1),XX),(LM(1),MM)
      EQUIVALENCE (MASK(1),MAS(1))
      DATA MAS/
     $ -1,$1001,
     $ -1,$110001,
     $ -1,$010001,
     $ -1,$0000FFFF,
     $ -1,$0000FFF0,
     $ -1,$0000FF00,
     $ -1,$0000F000,
     $ -1,$00000000,
     $ $10001,$00000000,
     $ $110001,$00000000,
     $ $1110001,$00000000,
     $ $0000FFFF,$00000000,
     $ $0000FFF0,$00000000,
     $ $0000FF80,$00000000/
      DATA XEXP/$00000180/
      DATA IBMASK/$70001,$30001,$10001/
C
      FLP(1) = FLP(1) + 1
      K = FLP(2)
      FLOP = X
      IF (K .LE. 0) RETURN
      IF (K .EQ. 360) GO TO 360
      IF (K .EQ. 541) GO TO 541
      FLOP = 0.0D0
      IF (K .GE. 15) RETURN
      XX = X
      MM = MASK(K)
      LX(1) = IAND(LX(1),LM(1))
      LX(2) = IAND(LX(2),LM(2))
      FLOP = XX
      RETURN
C
C     SIMULATE IBM/360 ARITHMETIC
C     LOOK AT LAST TWO BITS OF EXPONENT AND
C     CHOP 0, 1, 2 OR 3 BITS OFF THE FRACTION
C
  360 XX = X
      K = IAND(LX(1),XEXP)/128
      IF (K .GT. 0) LX(2) = IAND(LX(2),IBMASK(K))
      FLOP = XX
      RETURN
C
C     THE LOBO 541, 2 DIGIT DECIMAL FRACTION
C
  541 XX = DABS(X)
      IF (XX .GT. 9.9D0) XX = 9.9D0
      IF (XX .LT. 0.01D0) XX = 0.0D0
      IF (XX .GE. 1.0D0) XX = ROUND(10.D0*XX)/10.D0
      IF (XX.GE.0.1D0 .AND. XX.LT.1.0D0) XX = ROUND(100.D0*XX)/100.D0
      IF (XX .LT. 0.1D0) XX = ROUND(1000.D0*XX)/1000.D0
      IF (X .LT. 0.0D0) XX = -XX
      FLOP = XX
      RETURN
      END
      SUBROUTINE XCHAR(BUF,K)
      INTEGER BUF(1),K
C
C     SYSTEM DEPENDENT ROUTINE TO HANDLE SPECIAL CHARACTERS
C
      INTEGER DDT,ERR,FMT,LCT(4),LIN(1024),LPT(6),RIO,WIO,RTE,WTE,HIO
      COMMON /IOP/ DDT,ERR,FMT,LCT,LIN,LPT,RIO,WIO,RTE,WTE,HIO
      CHARACTER*80 S
      CHARACTER*1 BANG,TAB,BLANK
      INTEGER BLANKK
      DATA BANG/'!'/,TAB /'	'/,BLANK/' '/,BLANKK/37/
C
C     EXCLAMATION MARK, PASS REST OF LINE ON TO UNIX
C
      IF (CHAR(BUF(1)) .EQ. BANG) THEN
         DO 10 I = 1, 79
            S(I:I) = CHAR(BUF(I+1))
   10    CONTINUE
         S(80:80) = BLANK
C         CALL SYSTEM(S)
         K = 99
C
C     REPLACE TAB BY BLANK
C
      ELSE IF (CHAR(BUF(1)) .EQ. TAB) THEN
         K = BLANKK
C
C     ANYTHING ELSE PRODUCES ERROR MESSAGE
C
      ELSE
         WRITE(WTE,20) CHAR(BUF(1))
   20    FORMAT(A1,' IS NOT A MATLAB CHARACTER.')
C
      ENDIF
      RETURN
      END
      SUBROUTINE USER(A,M,N,S,T)
      DOUBLE PRECISION A(M,N),S,T
C
      INTEGER A3(9)
      DATA A3 /-149,537,-27,-50,180,-9,-154,546,-25/
      IF (A(1,1) .NE. 3.0D0) RETURN
      DO 10 I = 1, 9
         A(I,1) = A3(I)
   10 CONTINUE
      M = 3
      N = 3
      RETURN
      END
      SUBROUTINE PROMPT(PAUSE)
      INTEGER PAUSE
C
C     ISSUE MATLAB PROMPT WITH OPTIONAL PAUSE
C
      INTEGER DDT,ERR,FMT,LCT(4),LIN(1024),LPT(6),RIO,WIO,RTE,WTE,HIO
      COMMON /IOP/ DDT,ERR,FMT,LCT,LIN,LPT,RIO,WIO,RTE,WTE,HIO
      CHARACTER DUMMY
      WRITE(WTE,10)
      IF (WIO .NE. 0) WRITE(WIO,10)
   10 FORMAT(/'<>')
      IF (PAUSE .EQ. 1) READ(RTE,20) DUMMY
   20 FORMAT(A1)
      RETURN
      END
      SUBROUTINE PLOT(LUNIT,X,Y,N,P,K,BUF)
      DOUBLE PRECISION X(N),Y(N),P(1)
      INTEGER BUF(79)
C
C     PLOT X VS. Y ON LUNIT
C     IF K IS NONZERO, THEN P(1),...,P(K) ARE EXTRA PARAMETERS
C     BUF IS WORK SPACE
C
      DOUBLE PRECISION XMIN,YMIN,XMAX,YMAX,DY,DX,Y1,Y0
      CHARACTER AST,BLANK
      CHARACTER CBUF(79)
      INTEGER H,W
      DATA AST/'*'/,BLANK/' '/,H/20/,W/79/
C
C     H = HEIGHT, W = WIDTH
C
      XMIN = X(1)
      XMAX = X(1)
      YMIN = Y(1)
      YMAX = Y(1)
      DO 10 I = 1, N
         XMIN = DMIN1(XMIN,X(I))
         XMAX = DMAX1(XMAX,X(I))
         YMIN = DMIN1(YMIN,Y(I))
         YMAX = DMAX1(YMAX,Y(I))
   10 CONTINUE
      DX = XMAX - XMIN
      IF (DX .EQ. 0.0D0) DX = 1.0D0
      DY = YMAX - YMIN
      WRITE(LUNIT,35)
      DO 40 L = 1, H
         DO 20 J = 1, W
            BUF(J) = ICHAR(BLANK)
   20    CONTINUE
         Y1 = YMIN + (H-L+1)*DY/H
         Y0 = YMIN + (H-L)*DY/H
         JMAX = 1
         DO 30 I = 1, N
            IF (Y(I) .GT. Y1) GO TO 30
            IF (L.NE.H .AND. Y(I).LE.Y0) GO TO 30
            J = 1 + (W-1)*(X(I) - XMIN)/DX
            BUF(J) = ICHAR(AST)
            JMAX = MAX0(JMAX,J)
   30    CONTINUE
         DO 355 J=1,JMAX
           CBUF(J)=CHAR(BUF(J))
  355    CONTINUE
         WRITE(LUNIT,35) (CBUF(J),J=1,JMAX)
   35    FORMAT(79A1)
   40 CONTINUE
      RETURN
      END
      SUBROUTINE EDIT(BUF,N)
      RETURN
      END
      SUBROUTINE HELPER(H)
      INTEGER H(4)
C
C     HANDLE HELP FILE
C     H = KEY WORD, FORMAT 4A1
C
C     TWO DIRECT ACCESS FILES ARE REQUIRED.  THEIR LOCATIONS ARE:
C
      CHARACTER*(*) IDFILE,DAFILE
      PARAMETER(IDFILE='D:\LIB\MATHELP.IDX')
      PARAMETER(DAFILE='D:\LIB\MATHELP.DAC')
C
      PARAMETER(LRECL=66)
      CHARACTER*66 LINE
      CHARACTER*4 KEYS(128),KEY
      INTEGER LOCS(128)
      INTEGER DDT,ERR,FMT,LCT(4),LIN(1024),LPT(6),RIO,WIO,RTE,WTE,HIO
      COMMON /IOP/ DDT,ERR,FMT,LCT,LIN,LPT,RIO,WIO,RTE,WTE,HIO
      COMMON /HELPP/ KEYS,LOCS,KEY,LINE,NKEYS
C
C     INITIALIZATION INDICATED BY H(1) = 0
C
      IF (H(1) .EQ. 0) THEN
         OPEN(UNIT=HIO,FILE=IDFILE,ACCESS='DIRECT',RECL=8)
         N = 0
   10    N = N + 1
         READ(HIO,REC=N,ERR=15) KEYS(N),LOCS(N)
         IF (KEYS(N) .NE. 'EOF ') GO TO 10
   15    CLOSE(UNIT=HIO)
         NKEYS = N-1
         KEY = 'HELP'
         OPEN(UNIT=HIO,FILE=DAFILE,ACCESS='DIRECT',RECL=LRECL)
      ENDIF
C
C     CONVERT H TO CONVENTIONAL STRING
C
      IF (H(1) .NE. 0) THEN
         DO 20 I = 1, 4
            KEY(I:I) = CHAR(H(I))
   20    CONTINUE
      ENDIF
C
C     SPECIAL CASE, HELP FOLLOWED BY BLANK.  GIVE GENERAL HELP.
C
      IF (KEY .EQ. '    ') THEN
         WRITE(WTE,30)
         IF (WIO .NE. 0) WRITE(WIO,30)
   30    FORMAT(0X,'TYPE HELP FOLLOWED BY'
     >      /0X,'INTRO   (TO GET STARTED)'
     >      /0X,'NEWS    (RECENT REVISIONS)')
         WRITE(WTE,31) (KEYS(N), N = 19, NKEYS)
         IF (WIO .NE. 0) WRITE(WIO,31) (KEYS(N), N = 19, NKEYS)
   31    FORMAT(0X,A6,10A6)
         WRITE(WTE,32) (KEYS(N), N = 4, 18)
         IF (WIO .NE. 0) WRITE(WIO,32) (KEYS(N), N = 4, 18)
   32    FORMAT(0X,15(A1,1X))
         RETURN
      ENDIF
C
C     FIND KEY WORD IN KEYS TABLE
C
      DO 40 K = 1, NKEYS
         IF (KEY .EQ. KEYS(K)) GO TO 50
   40 CONTINUE
      WRITE(WTE,45) KEY
      IF (WIO .NE. 0) WRITE(WIO,45) KEY
   45 FORMAT(0X,'SORRY, NO HELP ON ',A4)
      RETURN
C
C     READ AND ECHO LINES FROM DIRECT ACCESS HELP FILE
C
   50 WRITE(WTE,75)
      IF (WIO .NE. 0) WRITE(WIO,75)
      K0 = LOCS(K)
      K1 = LOCS(K+1) - 2
      DO 80 K = K0, K1
   60    READ(HIO,REC=K) LINE
         DO 65 J = LRECL, 1, -1
            IF (LINE(J:J) .NE. ' ') GO TO 70
   65    CONTINUE
   70    WRITE(WTE,75) LINE(1:J)
         IF (WIO .NE. 0) WRITE(WIO,75) LINE(1:J)
   75    FORMAT(0X,A)
   80 CONTINUE
      RETURN
      END
